(: The XQuery prolog, where we set up the variables we're expecting :)
declare variable $AppleTopicListStyleSheetURL as xs:string external;
declare variable $AppleTopicListHeadline as xs:string external;
declare variable $AppleTopicListResults external;
declare function local:documents() as anyAtomicType*
{
	for $item in $AppleTopicListResults
	let $d := doc($item/url)
	let $t := data($d/descendant-or-self::title[1])
	return
		(<p>t={$t}</p>, <p>{data($item/url)}</p>)
};
declare variable $docs := local:documents();
declare function local:make-inner($alpha as xs:string) as xs:string
{
	for $item in $docs//a[@name='altxindex' and starts-with(@_topic, $alpha)]
		let $topic := data($item/descendant-or-self::a[@name='altxindex'][1]/@_topic)
		order by $topic
		return
<div class="indexitem">
<div class="indexentrytext"> 
<a href="{data($item/url)}">{$topic}</a></div>
<div class="seealsotext"><span class="seealsoprefix"></span></div></div>
};
declare function local:make-result($alpha as xs:string) as xs:string
{
	if ($docs/descendant-or-self::a[@name='altxindex' and starts-with(@_topic, $alpha)][1])
		then
			(<div class ="letterhead"><a name="{upper-case($alpha)}"></a>{upper-case($alpha)}</div>,
			make-inner($alpha))
		else
			()
};

<html>
<head>
<title>{$AppleTopicListHeadline}</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta name="template" content="index"/>
<meta name="pagetype" content="index"/>
<meta name="robots" content="anchors"/>
<link href="{$AppleTopicListStyleSheetURL}" rel="stylesheet" type="text/css"/>
</head>

<body id="apple-pd">
<script>
function go(target)
{{
window.location = target;
window.scrollBy(0,-60);
}}
</script>
<!--top navigation area-->
<div id="navbox" class="gradient">
<div id="navleftbox">
<a class="navlink_left" href="help:anchor='access' bookID=net.fractal.Flirt.help">Home</a>
</div>
</div>
<!--closes navigation area-->
<!--alphabet area-->
<div id="alpharow">
<div id="alphabox">
{
	for $a in ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z')
	return
		if ($docs/descendant-or-self::a[@name='altxindex' and starts-with(@_topic, $a)][1])
			then
<span class="alphaletters"><a href="javascript:go('#{upper-case($a)}');">{upper-case($a)}</a></span>
			else
<span class="alphaletters">{upper-case($a)}</span>
}
<span class="asterisk">*</span>
</div>
</div>
<!-- closes alphabet area --><!--list area-->
<div id="indexlist">
{
	for $a in ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z')
	return
		local:make-result($a)
}
</div>
<div id="padbottom"></div>
</body>
</html>